package com.yutou.mobilecloud.Controllers;

import com.alibaba.fastjson.JSONObject;
import com.yutou.mobilecloud.Enums.UserEnum;
import com.yutou.mobilecloud.Services.IUser;
import com.yutou.mobilecloud.mybatis.model.TUser;
import com.yutou.mobilecloud.utils.UserTools;
import org.springframework.stereotype.Controller;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;

@Controller
public class UserController {
    @Resource
    IUser iUser;

    @RequestMapping("/user/sign.do")
    @ResponseBody
    public JSONObject userSign(String username, String password) {
        JSONObject json = new JSONObject();
        TUser user = new TUser();
        user.setUsername(username);
        user.setPassword(password);
        UserEnum signEnum = iUser.userSign(user);
        user = iUser.getUser(user);
        json.put("code", signEnum.getCode());
        json.put("msg", signEnum.getMsg());
        if (signEnum == UserEnum.SIGN_SUCCESS) {
            JSONObject data = new JSONObject();
            data.put("token", UserTools.getToken(user));
            json.put("data", data);
        }
        return json;
    }

    @RequestMapping("/user/login.do")
    @ResponseBody
    public JSONObject login(String username, String password,String token) {
        JSONObject json = new JSONObject();
        TUser user = new TUser();
        UserEnum userEnum;
        if(StringUtils.hasLength(token)) {
            user.setUsername(username);
            user.setPassword(password);
            userEnum = iUser.login(user);
        }else {
            int check=UserTools.checkTokenGetUid(token);
            switch (check) {
                case -1 -> userEnum = UserEnum.LOGIN_FAIL_TOKEN;
                case -2 -> userEnum = UserEnum.LOGIN_FAIL_TIMEOUT;
                default -> {
                    userEnum = UserEnum.LOGIN_SUCCESS;
                    user.setId(check);
                }
            }
        }
        json.put("code", userEnum.getCode());
        json.put("msg", userEnum.getMsg());
        if (userEnum == UserEnum.LOGIN_SUCCESS) {
            user= iUser.getUser(user);
            json.put("data", loginJson(user));
        }
        return json;
    }

    public JSONObject loginJson(TUser user) {

        JSONObject json=new JSONObject();
        json.put("token",UserTools.getToken(user));
        return json;
    }

}
