package com.yutou.mobilecloud.Services.impls;

import com.yutou.mobilecloud.Services.IBackup;
import com.yutou.mobilecloud.mybatis.dao.*;
import com.yutou.mobilecloud.mybatis.model.*;
import com.yutou.mobilecloud.utils.Tools;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.File;
import java.util.Date;
import java.util.List;
import java.util.Objects;

@Service("Backup")
public class IBackupImpl implements IBackup {
    @Resource
    TUserDao userDao;
    @Resource
    TBackupFileDao fileDao;
    @Resource
    TBackupImageDao imageDao;
    @Resource
    TBackupAppDao appDao;
    @Resource
    TBackupInfoDao infoDao;
    @Resource
    TUserConfigDao configDao;


    @Override
    public boolean addImage(TUser user, TBackupFile backupFile, TBackupImage image) {
        int fid = getFileId(backupFile, user, "images" + File.separator + image.getPath().replace("/", File.separator));
        image.setFid(fid);
        image.setUid(user.getId());
        image.setCreatetime(new Date());
        return imageDao.insert(image) > 0;
    }

    @Override
    public boolean addApp(TUser user, TBackupFile backupFile, TBackupApp app) {
        int fid = getFileId(backupFile, user, "apps");
        app.setFid(fid);
        app.setUid(user.getId());
        app.setCreatetime(new Date());
        return appDao.insert(app) > 0;
    }

    @Override
    public boolean addNumber(TUser user, TBackupFile backupFile, TBackupInfo info, TUserConfig config) {
        int fid = getFileId(backupFile, user, "phone"+File.separator+"number");
        info.setFid(fid);
        info.setUid(info.getUid());
        info.setCreatetime(new Date());
        return infoDao.insert(info) > 0;
    }

    @Override
    public boolean addMessage(TUser user, TBackupFile backupFile, TBackupInfo info, TUserConfig config) {
        int fid = getFileId(backupFile, user, "phone"+File.separator+"message");
        info.setFid(fid);
        info.setUid(info.getUid());
        info.setCreatetime(new Date());
        return infoDao.insert(info) > 0;
    }

    @Override
    public boolean removeImage(int bid) {
        return false;
    }

    @Override
    public boolean removeApp(int bid) {
        return false;
    }

    @Override
    public boolean removeInfo(int bid) {
        return false;
    }

    @Override
    public List<TBackupImage> getImageList(int uid) {
        return null;
    }

    @Override
    public List<TBackupApp> getAppList(int uid) {
        return null;
    }

    @Override
    public List<TBackupInfo> getInfoList(int uid) {
        return null;
    }

    private int getFileId(TBackupFile file, TUser user, String dir) {
        File path = new File("backups" + File.separator + user.getId() + File.separator + dir);
        if (!path.exists()) {
            path.mkdirs();
        }
        File _file = new File(file.getFilepath());
        File newFile = new File(path.getAbsolutePath() + File.separator + Tools.getToDayNowTimeToFileName() + "_" + file.getFilename());
        _file.renameTo(newFile);
        file.setFilepath(newFile.getAbsolutePath());
        return fileDao.insert(file);
    }

    private File getBackupPath(TUser user, String dir) {
        File file = new File("backups" + File.separator + user.getId() + File.separator + dir);
        if (!file.exists()) {
            file.mkdirs();
        }
        return file;
    }
}
