package com.yutou.mobilecloud.Services.impls;

import com.yutou.mobilecloud.Enums.UserEnum;
import com.yutou.mobilecloud.Services.IUser;
import com.yutou.mobilecloud.mybatis.dao.TUserDao;
import com.yutou.mobilecloud.mybatis.model.TUser;
import com.yutou.mobilecloud.mybatis.model.TUserExample;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

import static com.yutou.mobilecloud.utils.UserTools.checkTokenGetUid;

@Service("User")
public class IUserImpl implements IUser {
    public static final String LOGIN_KEY = "G9PRGhDXDVAbK1He";
    @Resource
    TUserDao userDao;


    @Override
    public UserEnum userSign(TUser user) {
        if (isNewUser(user)) {
            if (StringUtils.hasLength(user.getUsername()) &&
                    StringUtils.hasLength(user.getPassword())
            ) {
                user.setCreatetime(new Date());
                userDao.insert(user);
                return UserEnum.SIGN_SUCCESS;
            }
            return UserEnum.SIGN_FAIL_PARAMETER;
        }
        return UserEnum.SIGN_FAIL_USER_EXIST;
    }

    @Override
    public UserEnum login(TUser user) {
        TUserExample example = new TUserExample();
        example.createCriteria().andUsernameEqualTo(user.getUsername())
                .andPasswordEqualTo(user.getPassword());
        if (userDao.selectByExample(example).isEmpty()) {
            example.clear();
            example.createCriteria().andUsernameEqualTo(user.getUsername());
            if (userDao.selectByExample(example).isEmpty()) {
                return UserEnum.LOGIN_FAIL_NOT_USER;
            }
            return UserEnum.LOGIN_FAIL_NOT_USER;
        }
        return UserEnum.LOGIN_SUCCESS;
    }

    @Override
    public boolean isNewUser(TUser user) {
        TUserExample example = new TUserExample();
        example.createCriteria().andUsernameEqualTo(user.getUsername());
        return !userDao.selectByExample(example).isEmpty();
    }

    @Override
    public TUser getUser(String token) {
        int uid=checkTokenGetUid(token);
        if(uid>0){
            return userDao.selectByPrimaryKey(uid);
        }
        return null;
    }

    @Override
    public TUser getUser(TUser user) {
        TUserExample example=new TUserExample();
        example.createCriteria().andUsernameEqualTo(user.getUsername()).andPasswordEqualTo(user.getPassword());
        List<TUser> list=userDao.selectByExample(example);
        if(list.isEmpty()){
            return null;
        }
        return list.get(0);
    }

    @Override
    public TUser getUser(int uid) {
        return userDao.selectByPrimaryKey(uid);
    }


    public static void main(String[] args) {
       TUser user=new TUser();
       user.setUsername("123");
        System.out.println(user);
    }
}
