package com.yutou.mobilecloud.utils;

import com.yutou.mobilecloud.mybatis.model.TUser;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

import static com.yutou.mobilecloud.Services.impls.IUserImpl.LOGIN_KEY;

public class UserTools {

    public static String getToken(TUser user) {
        String str = String.format("%d|%s|%s",
                user.getId(),
                user.getUsername(),
                LocalDateTime.now().plusMonths(1).format(DateTimeFormatter.ISO_LOCAL_DATE_TIME)
        );
        return AESTools.encrypt(Tools.stringToBase64(str), LOGIN_KEY);
    }

    public static int checkTokenGetUid(String token) {
        String str = Tools.base64ToString(AESTools.decrypt(token, LOGIN_KEY));
        if (str != null) {
            String[] sp = str.split("\\|");
            int uid = Integer.parseInt(sp[0]);
            String outTime = sp[2];
            boolean isOut = LocalDateTime.now().isAfter(LocalDateTime.parse(outTime));
            if (isOut) {
                return -2;
            }
            return uid;
        }
        return -1;
    }
}
